; PLAYIT.ASM: Wave and Midi player by nuMIT_or, Venezuela 1999
; for NASM

; Contact: nuMIT_or@iname.com

; ----------------------- Import Functions

; Include some definitions
; Incluir algunas definiciones
%INCLUDE "C:\TA\INCLUDE\Win32n.inc"

; External functions
; Funciones externas

EXTERN GetOpenFileNamePreview
IMPORT GetOpenFileNamePreview MSVFW32.DLL
EXTERN MCIWndCreate
IMPORT MCIWndCreate MSVFW32.DLL

EXTERN GetModuleHandleA
IMPORT GetModuleHandleA KERNEL32.DLL
EXTERN ExitProcess
IMPORT ExitProcess KERNEL32.DLL 
EXTERN lstrcpy
IMPORT lstrcpy KERNEL32.DLL
EXTERN lstrcat
IMPORT lstrcat KERNEL32.DLL

EXTERN SendMessageA
IMPORT SendMessageA USER32.DLL
EXTERN MessageBoxA
IMPORT MessageBoxA USER32.DLL
EXTERN LoadIconA
IMPORT LoadIconA USER32.DLL
EXTERN DialogBoxParamA
IMPORT DialogBoxParamA USER32.DLL
EXTERN EndDialog
IMPORT EndDialog USER32.DLL
EXTERN LoadMenuA
IMPORT LoadMenuA USER32.DLL
EXTERN SetMenu
IMPORT SetMenu USER32.DLL
EXTERN SetDlgItemTextA
IMPORT SetDlgItemTextA USER32.DLL
EXTERN GetDlgItem
IMPORT GetDlgItem USER32.DLL

; MCI window styles
; estilos de ventana MCI
MCIWNDF_NOAUTOSIZEWINDOW    EQU 0001h  
MCIWNDF_NOPLAYBAR           EQU 0002h 
MCIWNDF_NOAUTOSIZEMOVIE     EQU 0004h
MCIWNDF_NOMENU              EQU 0008h 
MCIWNDF_SHOWNAME            EQU 0010h 
MCIWNDF_SHOWPOS             EQU 0020h 
MCIWNDF_SHOWMODE            EQU 0040h 
MCIWNDF_SHOWALL             EQU 0070h  

MCIWNDF_NOTIFYMODE          EQU 0100h 
MCIWNDF_NOTIFYPOS           EQU 0200h 
MCIWNDF_NOTIFYSIZE          EQU 0400h 
MCIWNDF_NOTIFYERROR         EQU 1000h 
MCIWNDF_NOTIFYALL           EQU 1F00h

MCIWNDF_NOTIFYANSI	    EQU 0080h

; Resources IDs
; Identificadores de los recursos
IDM_MENU            EQU 4011
IDM_ABRIR           EQU 4101
IDM_PARAR           EQU 4105
IDM_SALIR  	    EQU 4106         
IDM_ACERCA          EQU 4107

IDC_EDIT            EQU 3000
IDC_BUTTON          EQU 3001
IDC_EXIT            EQU 3002
IDC_STATIC	    EQU -1

ID_1		    EQU 041

ICON_SMALL	    EQU 0
ICON_BIG	    EQU 1

;========================= Code Section

 SECTION CODE USE32 CLASS=CODE
 ..start:

; Get the module memory base
; Obtener la base de este mdulo en memoria

PUSH DWORD 0
CALL [GetModuleHandleA]
MOV [hInst],eax

; Create and show main dialog
; Crear y mostrar el dilogo principal

PUSH BYTE 0
PUSH DWORD DlgProc
PUSH BYTE 0
PUSH DWORD DlgName
PUSH DWORD [hInst]
CALL [DialogBoxParamA]

; End the process
; Terminar el proceso

PUSH BYTE 0
CALL [ExitProcess]

; Main Dialog Procedure: processes the messages to main dialog
; Procedimiento del dilogo principal: procesa los mensajes al dilogo principal
DlgProc:
%DEFINE hDlg EBP+8
%DEFINE msg EBP+12
%DEFINE wParam EBP+16
%DEFINE lParam EBP+20
ENTER 0,0

; Revise the main dialog messages
; Revisar los mensajes del dilogo principal

MOV eax,UINT [msg]
CMP eax,WM_INITDIALOG
JE init			
CMP eax,WM_COMMAND
JE  NEAR wmcommand
CMP eax,WM_CLOSE
JNE none
JMP close
none:
JMP return_false

	; Initiating main dialog
	; El dilogo principal se est inicializando

	init:
	
	; Set the icon
	; Poner un cono

	PUSH DWORD IcoName
	PUSH DWORD [hInst]
	CALL [LoadIconA]
	MOV  [hIco],eax

	PUSH    eax
	PUSH    DWORD ICON_SMALL
	PUSH    DWORD WM_SETICON
	PUSH    HWND [hDlg]
	call    [SendMessageA]

	; Set the menu
	; Poner el men

	PUSH DWORD MenuName
	PUSH DWORD [hInst]
	CALL [LoadMenuA]
	PUSH eax
	PUSH HWND[hDlg]
	CALL [SetMenu]
	JMP  cont1

	; To fill the OPENFILENAME struct
	; Llenar la estructura OPENFILENAME
cont1:
	PUSH DWORD FilterStr
	POP  DWORD [ofn+OPENFILENAME.lpstrFilter]
	MOV  eax,DWORD NameBuffer
	MOV  DWORD [ofn+OPENFILENAME.lpstrFile],eax
	MOV  DWORD [ofn+OPENFILENAME.nMaxFile],256
	MOV  DWORD [ofn+OPENFILENAME.Flags],OFN_LONGNAMES | OFN_EXPLORER | OFN_HIDEREADONLY
	JMP return_true

	; Process the WM_COMMAND message
	; Procesar el mensaje WM_COMMAND

	wmcommand:
	MOV eax,WPARAM [wParam]
	CMP ax,IDM_ABRIR
	JE abrir
	CMP ax,IDM_SALIR
	JE NEAR close
	CMP ax,IDC_EXIT
	JE NEAR close
	CMP ax,IDM_ACERCA
	JE NEAR acerca
return_false:
	XOR eax,eax
	LEAVE
	RET 16


		abrir:

		; Select a file
		; Seleccionar un archivo

		PUSH DWORD ofn
		CALL [GetOpenFileNamePreview]		
		CMP eax,0
		JE return_false

		; Is a loaded file?
		; Hay cargado un archivo?

		MOV eax,DWORD [hMCI]
		CMP eax,0
		JE  no_loaded
	
		; If a file is loaded, downloaded it
		; Si hay un archivo cargado, bajarlo

		PUSH BYTE 0
		PUSH BYTE 0
		PUSH DWORD WM_CLOSE
		PUSH DWORD [hMCI]
		CALL [SendMessageA]

		; Get the selected file name
		; Obtener el nombre del archivo seleccionado

		no_loaded:
		MOV  edi,DWORD NameBuffer
		XOR  eax,eax
		MOV  ecx,-1
		REPNE SCASB
		MOV  esi,edi
		STD
		isnot:
		LODSB
		CMP  al,'\'
		JNE  isnot
		add  esi,2
		CLD

		; Set the file name in the main dialog
		; Poner el nombre del archivo en el dilogo principal
				
		PUSH DWORD ID_1
		PUSH HWND [hDlg]
   		CALL [GetDlgItem]
		PUSH esi
		PUSH BYTE 0
		PUSH DWORD WM_SETTEXT
		PUSH eax
		CALL [SendMessageA]

		; Play de wav or mid file
		; Tocar el archivo wav o mid

		tocar:		
		PUSH DWORD NameBuffer
		PUSH DWORD WS_VISIBLE | WS_CHILD | MCIWNDF_NOMENU
		PUSH DWORD [hInst]
		PUSH HWND [hDlg]
		CALL [MCIWndCreate]
	        MOV  DWORD [hMCI],eax
return_true:	MOV eax,1
		LEAVE
		RET 16

		; Display About dialog box
		; Desplegar cuadro de dilogo Acerca...

		acerca:
		PUSH BYTE 0
		PUSH DWORD DlgAcercaProc
		PUSH HWND [hDlg]
		PUSH DWORD DlgAcerca
		PUSH DWORD [hInst]
		CALL [DialogBoxParamA]
		JMP  return_true	

	; Close the program
	; Cerrar el programa

	close:
	PUSH BYTE 0
	PUSH HWND [hDlg]
	CALL [EndDialog]
	JMP return_true

; About Dialog Procedure: processes the messages to About dialog
; Procedimiento del dilogo Acerca: procesa los mensajes al dilogo Acerca
DlgAcercaProc:
	%DEFINE hDlg2 EBP+8
	%DEFINE imsg EBP+12
	%DEFINE wParam2 EBP+16
	%DEFINE lParam2 EBP+20
	ENTER 0,0	
	
		MOV eax,UINT[imsg]
		CMP eax,WM_INITDIALOG
		JE  init_acerca
		CMP eax,WM_LBUTTONUP
		JE  close_acerca
		JMP return_false
init_acerca:	JMP return_true

		; Close About Dialog
		; Cerar dilogo about
close_acerca:
		PUSH BYTE 0
		PUSH HWND [hDlg2]
		CALL [EndDialog]
		JMP return_true


;========================= Data Section
		
[SECTION DATA USE32 CLASS=DATA] 
ofn:
ISTRUC OPENFILENAME
AT OPENFILENAME.lStructSize, DD OPENFILENAME_size
AT OPENFILENAME.hWndOwner,   DD 0
AT OPENFILENAME.hInstance,   DD 0
AT OPENFILENAME.lpstrFilter, DD 0
AT OPENFILENAME.lpstrCustomFilter, DD 0
AT OPENFILENAME.nMaxCustFilter, DD 0
AT OPENFILENAME.nFilterIndex, DD 0
AT OPENFILENAME.lpstrFile, DD 0
AT OPENFILENAME.nMaxFile, DD 0
AT OPENFILENAME.lpstrFileTitle, DD 0
AT OPENFILENAME.nMaxFileTitle, DD 0
AT OPENFILENAME.lpstrInitialDir, DD 0
AT OPENFILENAME.lpstrTitle, DD 0
AT OPENFILENAME.Flags, DD 0
AT OPENFILENAME.nFileOffset, DW 0
AT OPENFILENAME.nFileExtension, DW 0
AT OPENFILENAME.lpstrDefExt, DD 0
AT OPENFILENAME.lCustData, DD 0
AT OPENFILENAME.lpfnHook, DD 0
AT OPENFILENAME.lpTemplateName, DD 0
IEND

hInst	    DD 0
hIco	    DD 0
pFile	    DD 0
hMCI	    DD 0

FilterStr   DB 'Archivos (*.WAV, *.MID)',0,'*.WAV;*.MID',0,0

NameBuffer  times 260 DB (0)  
strzBuffer  times 260 DB (0)
IcoName     DB "WAV_ICON",0
DlgName     DB 'WavDlg',0
DlgAcerca   DB "CuadroAcercaDe",0
MenuName    DB "WavMenu",0


